package cn.axzo.msg.center.api.response.v3;

import com.alibaba.fastjson.JSON;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Optional;
import java.util.Set;

/**
 * @author yanglin
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class MessageSendRespV3 implements Serializable {
    /**
     * 这次批量发送的批次号, 如果配置了多个模版，多个渠道, 可以用批次号串联起来
     */
    private String batchNo;

    /**
     * 模版code -> 模版发送结果
     */
    private Map<String, TemplateSendResultV3> templateCode2SendResult;

    public void addResult(TemplateSendResultV3 result) {
        templateCode2SendResult.put(result.getTemplateCode(), result);
    }

    public Optional<TemplateSendResultV3> findTemplateSendResult(String templateCode) {
        return Optional.ofNullable(templateCode2SendResult.get(templateCode));
    }

    public Set<String> templateCodes() {
        return new HashSet<>(templateCode2SendResult.keySet());
    }

    public Map<String, TemplateSendResultV3> templateSendResults() {
        return Collections.unmodifiableMap(templateCode2SendResult);
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }
}